<?
error_reporting(E_ALL);
$kioskMode = false;

include '../php/filestorage.class.php';
include '../preferences.php';
include '../php/json.class.php';
include '../php/functions.php';
include '../php/yshout.class.php';
include '../php/ajaxcall.class.php';

if (isset($_POST['mode']))
	switch($_POST['mode']) {
		case 'login':
			doLogin();
			break;
		case 'logout':
			doLogout();
			break;
		case 'unban':
			doUnban();
			break;
		case 'unbanall':
			doUnbanAll();
			break;
		case 'setpreference':
			doSetPreference();
			break;
		case 'resetpreferences':
			doResetPreferences();
			break;
	}

function doLogin() {
	global $kioskMode;
	
	if ($kioskMode) {
		logout();
		$result = array(
			'error' => false,
			'html' => cp()
		);
		
		echo jsonEncode($result);
		return;
	}
	
	login(md5($_POST['password']));
	$result = array();
	if (loggedIn()) {
		$result['error'] = false;
		$result['html'] = cp();
	} else
		$result['error'] = 'invalid';

	echo jsonEncode($result);
}

function doLogout() {
	logout();

	$result = array(
		'error' => false
	);

	echo jsonEncode($result);
}

function doUnban() {
	global $kioskMode;
	
	if ($kioskMode) {
		$result = array(
			'error' => false
		);
		
		echo jsonEncode($result);
		return;
	}
	
	if (!loggedIn()) return;

	$ys = ys();
	$result = array();

	$ip = $_POST['ip'];

	if ($ys->banned($ip)) {
		$ys->unban($ip);
		$result['error'] = false;
	} else
		$result['error'] = 'notbanned';


	echo jsonEncode($result);
}

function doUnbanAll() {
	global $kioskMode;
	
	if ($kioskMode) {
		$result = array(
			'error' => false
		);
		
		echo jsonEncode($result);
		return;
	}
	
	if (!loggedIn()) return;

	$ys = ys();
	$ys->unbanAll();

	$result = array(
		'error' => false
	);

	echo jsonEncode($result);
}


function doSetPreference() {
	global $prefs, $kioskMode;
	
	if ($kioskMode) {
		$result = array(
			'error' => false
		);
		
		echo jsonEncode($result);
		return;
	}
	
	if (!loggedIn()) return;

	$pref = $_POST['preference'];
	$value = magic($_POST['value']);

	if ($value === 'true') $value = true;
	if ($value === 'false') $value = false;

	$prefs[$pref] = $value;

	savePrefs($prefs);

	if ($pref == 'password') login(md5($value));

	$result = array(
		'error' => false
	);

	echo jsonEncode($result);
}


function doResetPreferences() {
	global $prefs, $kioskMode;
	
	if ($kioskMode) {
		$result = array(
			'error' => false
		);
		
		echo jsonEncode($result);
		return;
	}
	
	if (!loggedIn()) return;

	resetPrefs();
	login(md5($prefs['password']));

	//	$prefs['password'] = 'lol no';
	$result = array(
		'error' => false,
		'prefs' => $prefs
	);

	echo jsonEncode($result);
}

/* CP Display */

function cp() {
	global $kioskMode;
	
	if (!loggedIn() && !$kioskMode) return 'Nie jesteś zalogowany!';

	return '

				<div class="section" id="preferences">
				<span style="display: none;" id="cp-loaded">true</span>
					<div class="header">
						<h1>YShout.Ustawienia</h1>
						<a href="#" class="logout">Wyloguj się</a>
					</div>

					<ul class="subnav">
						<li id="sn-administration"><a href="#">Ustawienia główne</a></li>
						<li id="sn-display"><a href="#">Wyświetlanie</a></li>
						<li id="sn-resetall"><a href="#">Zapisz ustawienia domyślne</a></li>
						<span class="sn-loading">Wczytywanie...</span>
					</ul>

					' . preferencesForm() . '
				</div>

				<div class="section" id="about">
					<div class="header">
						<h1>YShout.About</h1>
						<a href="#" class="logout">Wyloguj się</a>
					</div>

					<ul class="subnav">
						<li id="sn-about"><a href="#">About</a></li>
						<li id="sn-contact"><a href="#">Contact</a></li>
						<span class="sn-loading">Wczytywanie...</span>
					</ul>

					' . about() . ' 
				</div>

				<div class="section" id="bans">
					<div class="header">
						<h1>YShout.Ban</h1>
						<a href="#" class="logout">Wyloguj się</a>
					</div>

					<ul class="subnav">
						<li id="sn-unbanall"><a href="#">Odbanuj wszystkich</a></li>
						<span class="sn-loading">Wczytywanie...</span>
					</ul>

					' . bansList() . '
					
				</div>';
}

function bansList() {
	global $kioskMode;
	
	$ys = ys();
	$bans = $ys->bans();

	$html = '<ul id="bans-list">';

	$hasBans = false;
	foreach($bans as $ban) {
		$hasBans = true;
		$html .= '
			<li>
				<span class="nickname">' . $ban['nickname']. '</span>
				(<span class="ip">' . ($kioskMode ? '[No IP in Kiosk Mode]' : $ban['ip']) . '</span>)
				<a title="Unban" class="unban-link" href="#" rel="' . $ban['timestamp'] . '">Unban</a>
			</li>
		';
	}
	
	if (!$hasBans)
		$html = '<p id="no-bans">Nikt nie został jeszcze zbanowany.</p>';
	else
		$html .= '</ul>';

	return $html;
}

function preferencesForm() {
	global $prefs, $kioskMode;

	return '
					<form id="preferences-form">
						<div id="cp-pane-administration" class="cp-pane">
							<fieldset id="prefs-cat-cp">
								<div class="legend">Panel administracyjny</div class="legend">
								<ol>
									<li>
										<label for="pref-password">Hasło administratora</label>
										<input rel="password" type="text" id="pref-password" value="' . ($kioskMode ? 'No password in Kiosk Mode.' : $prefs['password']) . '" />
									</li>
								</ol>
							</fieldset>

							<fieldset id="prefs-cat-flood">
								<div class="legend">Flood kontrola</div class="legend">
								<ol>
									<li>
										<label for="pref-flood">Używać flood kontroli</label>
										<select rel="flood" id="pref-flood">
											<option' . ($prefs['flood'] == true ? ' selected' : '') . ' rel="true">Tak</option>
											<option' . ($prefs['flood'] == false ? ' selected' : '') . ' rel="false">Nie</option>
										</select>
									</li>
									<li>
										<label for="pref-flood-timeout">Limit czasowy</label>
										<input rel="floodTimeout" type="text" id="pref-flood-timeout" value="' . $prefs['floodTimeout'] . '" />
									</li>
									<li>
										<label for="pref-flood-messages">Liczba wiadomości</label>
										<input rel="floodMessages" type="text" id="pref-flood-messages" value="' . $prefs['floodMessages'] . '" />
									</li>
									<li>
										<label for="pref-flood-length">Długość</label>
										<input rel="floodDisable" type="text" id="pref-flood-length" value="' . $prefs['floodDisable'] . '" />
									</li>
									<li>
										<label for="pref-flood-autoban">Automatycznie banuj po</label>
										<select rel="autobanFlood" id="pref-flood-autoban">
											<option' . ($prefs['autobanFlood'] == 1 ? ' selected' : '') . ' rel="1">1 aktywacji</option>
											<option' . ($prefs['autobanFlood'] == 2 ? ' selected' : '') . ' rel="2">2 aktywacjach</option>
											<option' . ($prefs['autobanFlood'] == 3 ? ' selected' : '') . ' rel="3">3 aktywacjach</option>
											<option' . ($prefs['autobanFlood'] == 4 ? ' selected' : '') . ' rel="4">4 aktywacjach</option>
											<option' . ($prefs['autobanFlood'] == 5 ? ' selected' : '') . ' rel="5">5 aktywacjach</option>
											<option' . ($prefs['autobanFlood'] == 0 ? ' selected' : '') . ' rel="false">Nigdy</option>
										</select>
									</li>
								</ol>
							</fieldset>

							<fieldset id="prefs-cat-history">
								<div class="legend">Historia</div class="legend">
								<ol>
									<li>
										<label for="pref-max-logs">Dozwolona liczba logów</label>
										<input rel="logs" type="text" id="pref-max-logs" value="' . $prefs['logs'] . '" />
									</li>
									<li>
										<label for="pref-history-shouts">Liczba postów w historii</label>
										<input rel="history" type="text" id="pref-history-shouts" value="' . $prefs['history'] . '" />
									</li>
								</ol>
							</fieldset>

							<fieldset id="prefs-cat-misc">
								<div class="legend">Dodatkowe</div class="legend">
								<ol>
									<li>
										<label for="pref-refresh-rate">Częstotliwość odświeżania</label>
										<input rel="refresh" type="text" id="pref-refresh-rate" value="' . $prefs['refresh'] . '" />
									</li>
									<li>
										<label for="pref-censor-words">Zablokowane słowa</label>
										<input rel="censorWords" type="text" id="pref-censor-words" value="' . $prefs['censorWords'] . '" />
									</li>
								</ol>
							</fieldset>
						</div>

						<div id="cp-pane-display" class="cp-pane">
							<fieldset id="prefs-cat-form">
								<div class="legend">Ustawienia formularza</div class="legend">
								<ol>
									<li>
										<label for="pref-form-position">Pozycja formularza</label>
										<select rel="inverse" id="pref-form-position">
											<option' . ($prefs['inverse'] == true ? ' selected' : '') . ' rel="true">U góry</option>
											<option' . ($prefs['inverse'] == false ? ' selected' : '') . ' rel="false">Na dole</option>
										</select>
									</li>
									<li>
										<label for="pref-message-text">Domyślny tekst</label>
										<input rel="defaultMessage" type="text" id="pref-message-text" value="' . $prefs['defaultMessage'] . '" />
									</li>
									<li>
										<label for="pref-submit-text">Tekst na przycisku</label>
										<input rel="defaultSubmit" type="text" id="pref-submit-text" value="' . $prefs['defaultSubmit'] . '" />
									</li>
									<li>
										<label for="pref-message-length">Długość wiadomości</label>
										<input rel="messageLength" type="text" id="pref-message-length" value="' . $prefs['messageLength'] . '" />
									</li>
									<li>
										<label for="pref-show-submit">Przycisk wyślij</label>
										<select rel="showSubmit" id="pref-show-submit">
											<option' . ($prefs['showSubmit'] == true ? ' selected' : '') . ' rel="true">Tak</option>
											<option' . ($prefs['showSubmit'] == false ? ' selected' : '') . ' rel="false">Nie</option>
										</select>
									</li>
								</ol>
							</fieldset>

							<fieldset id="prefs-cat-shouts">
								<div class="legend">Ustawienia wiadomości</div class="legend">
								<ol>
									<li>
										<label for="pref-timestamp-format">Format czasu</label>
										<select rel="timestamp" id="pref-timestamp-format">
											<option' . ($prefs['timestamp'] == 12 ? ' selected' : '') . ' rel="12">12-godzinny</option>
											<option' . ($prefs['timestamp'] == 24 ? ' selected' : '') . ' rel="24">24-godzinny</option>
										</select>
									</li>
									<li>
										<label for="pref-truncate">Pokazuj wiadomości</label>
										<input rel="truncate" type="text" id="pref-truncate" value="' . $prefs['truncate'] . '" />
									</li>
									<li>
										<label for="pref-do-truncate">Obcinaj wiadomości</label>
										<select rel="doTruncate" id="pref-do-truncate">
											<option' . ($prefs['doTruncate'] == true ? ' selected' : '') . ' rel="true">Tak</option>
											<option' . ($prefs['doTruncate'] == false ? ' selected' : '') . ' rel="false">Nie</option>
										</select>
									</li>
									<li>
										<label for="pref-nickname-suffix">Suffix nazwy usera</label>
										<input rel="nicknameSeparator" type="text" id="pref-nickname-suffix" value="' . $prefs['nicknameSeparator'] . '" />
									</li>
								</ol>
							</fieldset>
						</div>
					</form>
	';
}

function about() {
	global $prefs;

	$html = '
		<div id="cp-pane-about" class="cp-pane">
			<h2>About YShout</h2>
			<p>YShout was created and developed by Yuri Vishnevsky. Version 5 is the first one with an about page, so you\'ll have to excuse the lack of appropriate information &mdash; I\'m not quite sure what it is that goes on "About" pages anyway.</p>
			<p>Other than that obviously important tidbit of information, there\'s really nothing else that I can think of putting here... If anyone knows what a good and proper about page should contain, please contact me!
		</div>
		
		<div id="cp-pane-contact" class="cp-pane">
			<h2>Contact Yuri</h2>
			<p>If you have any questions or comments, you can contact me by email at <a href="mailto:yurivish@gmail.com">yurivish@gmail.com</a>, or on AIM at <a href="aim:goim?screnname=yurivish42">yurivish42</a>.</p>
			<p>I hope you\'ve enjoyed using YShout!</p>
		</div>
		';

	
	return $html;
}

?>